////////////////////////////////////////////////////////////////////////
//
//        File  Name : terminal.h
//        Class Name : terminal
//        Author     : Young-ki Hwang
//        Date       : April 30, 1996
//        Description: This is the "terminal" class definition.
//                     It defines terminal setting.
//
///////////////////////////////////////////////////////////////////////

#include <curses.h>
#include <stdio.h>



extern "C" stty(...);
extern "C" gtty(...);

#ifndef _terminal_h
#define _terminal_h

class  terminal
{
  private :
      int max_line,    //  maximun number of lines of the terminal
          max_col;     //  maximun number of columnsof the terminal

  public :
      terminal()    { initscr();         // initialize the terminal-type data
                      max_line = LINES;  // max lines of terminal
		      max_col = COLS;    // max columns of terminal
		    }
      ~terminal()   { endwin(); }        // finish up the window routines
      makeecho()    { echo(); }          // allow window to echo
      makenoecho()  { noecho(); }        // allow window to noecho
      makenl()      { nl(); }            // make window to be nl mode
      makenonl()    { nonl(); }          // make window to be nonl mode
      makecbreak()  { cbreak();}         // make window to be cbreak mode
      makenocbreak(){ nocbreak();}       // make window to be nocbreak mode
      makeraw()     { raw(); }           // make window to be raw mode
      makenoraw()   { noraw();}          // make window to be noraw mode
      store()       { savetty();}        // save the terminla type data
      restore()     { resetty();}        // restore the terminal type data
      int getmaxline()  { return(max_line); } // get num of lines of terminal
      int getmaxcol()   { return(max_col); }  // get num of columns of terminal
}; 

#endif
